#include <iostream>
#include <string>

using namespace std;

int main()
{
    int n; //Broj pacijenata
    int o, a, b, ab; //Kolicina jedinica krvi
    //int po = o, pa = a, pb = b, pab = ab;
    bool moze = true;

    cin >> n; //Unos broja pacijenata
    cin >> o >> a >> b >> ab; //Unos broja jedinica krvi

    string pacijenti[n]; //Krvna grupa pacijenta
    int kolicina[n]; //Potreban broj jedinica krvi
    int ko[n], ka[n], kb[n], kab[n];

    for(int i=0; i<n; i++)
    {
        cin >> pacijenti[i] >> kolicina[i];
    }

    for(int i = 0; i<n; i++)
    {
        if(pacijenti[i] == "O")
        {
            if(kolicina[i]<=o)
            {
                o-=kolicina[i];
                ko[i] = kolicina[i];
                ka[i] = 0;
                kb[i] = 0;
                kab[i] = 0;
            }
            else{moze = false; break;}
        }
        else if(pacijenti[i] == "A")
        {
            if(kolicina[i]<=a)
            {
                a-=kolicina[i];
                ko[i] = 0;
                ka[i] = kolicina[i];
                kb[i] = 0;
                kab[i] = 0;
            }
            else
            {
                int priv = kolicina[i] - a;
                if(kolicina[i]>a && priv<=o)
                {
                    ko[i] = kolicina[i] - a;
                    ka[i] = kolicina[i] - ko[i];
                    kb[i] = 0;
                    kab[i] = 0;
                }
                else{moze = false; break;}
            }
        }
        else if(pacijenti[i]=="B")
        {
            if(kolicina[i]<=b)
            {
                ko[i] = 0;
                ka[i] = 0;
                kb[i] = kolicina[i];
                kab[i] = 0;
            }
            else if(kolicina[i]>b && (kolicina[i]-b)<=o)
            {
                int priv = kolicina[i] - b;
                ko[i] = priv;
                ka[i] = 0;
                kb[i] = kolicina[i] - priv;
                kab[i] = 0;
            }
            else{moze = false; break;}
        }
    }

    if(moze)
    {
        cout << "moguce" << endl;
        for(int i=0; i<n; i++)
        {
            cout << ko[i] << " " << ka[i] << " " << kb[i] << " " << kab[i] << endl;
        }
    }
    else
    {
        cout << "nemoguce";
    }
    return 0;
}